#include <ctype.h>
#include <dos.h>
#include <malloc.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "x_macros.h"
#include "x_alloc.hpp"
#include "x_text.hpp"

static int	getNumber(int *num, char *line, int *pos);

int ansiDimensionsRequested;

void wputch(char ch) {
  static int esc, ansiIntense, ansiInverse, ansiMove, ansiMoveX;
  static int ansiStrLen;
  static char ansiStr[64];
  static int wrapFlag, savedX, savedY;
  if (esc == 0) {
    if (ch == 27) {
      esc = 1;
      return;
    }
  } else if (esc == 1) {
    if (ch == '[') {
      esc = 2;
      ansiStr[0] = '\0'; ansiStrLen = 0;
      return;
    } else {
      esc = 0;
      return;
    }
  } else if (esc == 2) {
    int row, col, attr;
    int pos = 0;
    switch (ch) {
      case 'A':
        esc = 0;
        if (getNumber(&row, ansiStr, &pos)) row = 1;
	row = wherey() - row;
	row = max(1, row);
	gotoxy(wherex(), row);
	ansiMove = 1; ansiMoveX = wherex(); wrapFlag = 0;
	break;
      case 'B':
        esc = 0;
        if (getNumber(&row, ansiStr, &pos)) row = 1;
	row = wherey() + row;
	row = min(textrows(), row);
	gotoxy(wherex(), row);
	ansiMove = 1; ansiMoveX = wherex(); wrapFlag = 0;
	break;
      case 'C':
        esc = 0;
        if (getNumber(&col, ansiStr, &pos)) col = 1;
	col = wherex() + col;
	col = min(textcols(), col);
	gotoxy(col, wherey());
	ansiMove = 1; ansiMoveX = wherex(); wrapFlag = 0;
	break;
      case 'D':
        esc = 0;
        if (getNumber(&col, ansiStr, &pos)) col = 1;
	col = wherex() - col;
	col = max(1, col);
	gotoxy(col, wherey());
	ansiMove = 1; ansiMoveX = wherex(); wrapFlag = 0;
	break;
      case 'H':
      case 'f':
        esc = 0;
      	if (getNumber(&row, ansiStr, &pos)) col = row = 1;
	else {
	  if (getNumber(&col, ansiStr, &pos)) col = 1;
	  if (row > textrows()) row = textrows();
	  if (col > textcols()) col = textcols();
	}
	gotoxy(col, row);
	ansiMove = 1; ansiMoveX = wherex(); wrapFlag = 0;
	break;
      case 'J':
        esc = ansiMove = 0;
        textcolor(LIGHTGRAY); textbackground(BLACK);
	if (!getNumber(&attr, ansiStr, &pos) || (wherex() == 1 && wherey() == 1)) clrscr();
	break;
      case 'K':
        if (wherex() == 1 && wherey() == 1) clrscr();
        else clreol();
	esc = ansiMove = 0;
	break;
      case 'P': esc = 0; break;
      case 'R': esc = ansiMove = 0; break;
      case 'h': esc = ansiMove = 0; break;
      case 'l': esc = ansiMove = 0; textcolor(LIGHTGRAY); textbackground(BLACK); break;
      case 'm':
        esc = ansiMove = 0;
	if (!ansiStrLen) strcpy(ansiStr, "0");
        while (!getNumber(&attr, ansiStr, &pos)) {
	  if (attr == 0) {
	    ansiIntense = ansiInverse = 0;
	    textcolor(LIGHTGRAY); textbackground(BLACK);
	  } else if (attr == 1) {
	    ansiIntense = 1;
	    if (_gettextcolor() < 8) textcolor(_gettextcolor() + 8);
	  } else if (attr == 2) {
	    ansiIntense = 0;
	    if (_gettextcolor() >= 8) textcolor(_gettextcolor() - 8);
	  } else if (attr == 5) {
	    if (_getbkcolor() < 8) textbackground(_getbkcolor() + 8);
	  } else if (attr == 7) {
	    ansiInverse = 1;
	    attr = _gettextcolor();
	    if (attr >= 8) attr -= 8;
	    textcolor(_getbkcolor());
	    textbackground(attr);
	  } else if ((attr >= 30 && attr <= 37) || (attr >= 40 && attr <= 47)) {
	    int bg;
	    if (attr >= 40) {
	      bg = 1;
	      attr -= 10;
	    } else bg = 0;
	    int color;
	    switch (attr) {
              case 30: color = BLACK; break;
	      case 31: color = RED; break;
	      case 32: color = GREEN; break;
	      case 33: color = YELLOW; break;
	      case 34: color = BLUE; break;
	      case 35: color = MAGENTA; break;
	      case 36: color = CYAN; break;
	      case 37: color = LIGHTGRAY; break;
	    }
	    if (bg) textbackground(color);
	    else {
              if (ansiIntense) color += 8;
	      textcolor(color);
	    }
	  }
	}
	break;
      case 'n': esc = ansiMove = 0; ansiDimensionsRequested = 1; break;
      case 'r': esc = ansiMove = 0; break;
      case 's': esc = ansiMove = 0; savedX = wherex(); savedY = wherey(); break;
      case 'u':
        esc = 0;
	gotoxy(savedX, savedY);
	ansiMove = 1; ansiMoveX = wherex(); wrapFlag = 0;
        break;
      default:
        if (ansiStrLen < 63) {
	  ansiStr[ansiStrLen++] = ch;
	  ansiStr[ansiStrLen] = '\0';
	}
        if (isalpha(ch)) {
	  esc = 0;
	  outtext("\nunknown ansi escape: %s\n", ansiStr);
	  sleep(2);
	}
    }
    return;
  }
  if (wherex() != textcols()) wrapFlag = 0;
  if (ch == 7) {
    sound(500);
    delay(5);
    nosound();
    return;
  } else if (ch == 8) {
    if (wherex() > 1) {
      gotoxy(wherex() - 1, wherey());
      _outtext(" ");
      gotoxy(wherex() - 1, wherey());
    }
    return;
  } else if (ch == '\n' && ansiMove) {
    int row = wherey() + 1;
    if (row > textrows()) row = textrows();
    gotoxy(ansiMoveX, row);
    ansiMove = 0;
    return;
  } else if (ch == '\r' && ansiMove) {
    gotoxy(ansiMoveX, wherey());
    ansiMove = 0;
    return;
  }
  char s[2];
  s[1] = '\0';
  if (ch == '\t') {
    int newX = ((wherex() + 7) / 8) * 8 + 1;
    if (newX >= textcols()) s[0] = '\n';
    else {
      gotoxy(newX, wherey());
      return;
    }
  } else s[0] = ch;
  if (wherex() == textcols()) {
    if (wrapFlag) {
      wrapFlag = 0;
      _wrapon(_GWRAPON);
    } else {
      wrapFlag = 1;
      _wrapon(_GWRAPOFF);
    }
  }
  _outtext(s);
}

int getNumber(int *num, char *line, int *pos) {
  int i = *pos;
  int numStrLen = 0;
  char numStr[64];
  while (!isdigit(line[i]) && line[i]) i++;
  while (isdigit(line[i])) numStr[numStrLen++] = line[i++];
  numStr[numStrLen] = '\0';
  *pos = i;
  if (numStrLen) {
    *num = atoi(numStr);
    return 0;
  } else return 1;
}

int outtext(char *fmt, ...) {
  char *buf = (char*)smalloc(0x0400);
  buf[0] = 0;
  va_list argptr;
  va_start(argptr, fmt);
  int cnt = vsprintf(buf, fmt, argptr);
  va_end(argptr);
  char *s = buf;
  while (*s) wputch(*s++);
  sfree(buf);
  return cnt;
}

void clreol(void) {
  short col, r1, c1, r2, c2;
  struct rccoord coord;
  coord = _gettextposition();
  _gettextwindow(&r1, &c1, &r2, &c2);
  _wrapon(_GWRAPOFF);
  for (col = coord.col; col <= (c2 - c1 + 1); col++)
    _outtext(" ");
  _settextposition(coord.row, coord.col);
  _wrapon(_GWRAPON);
}

void delline(void) {
  short col, r1, c1, r2, c2;
  struct rccoord coord;
  coord = _gettextposition();
  _gettextwindow(&r1, &c1, &r2, &c2);
  _settextposition(coord.row, 1);
  _wrapon(_GWRAPOFF);
  for (col = 1; col <= (c2 - c1 + 1); col++)
    _outtext(" ");
  _settextposition(coord.row, coord.col);
  _wrapon(_GWRAPON);
}

int wherex() {
  struct rccoord pos = _gettextposition();
  return pos.col;
}

int wherey() {
  struct rccoord pos = _gettextposition();
  return pos.row;
}

void gettextinfo(text_info *ti) {
  text_info &t = *ti;
  short r1, c1, r2, c2;
  _gettextwindow(&r1, &c1, &r2, &c2);
  t.winleft = c1;
  t.wintop = r1;
  t.winright = c2;
  t.winbottom = r2;
  t.attribute = (_getbkcolor() << 4) | _gettextcolor();
  t.curx = wherex();
  t.cury = wherey();
}

void textattr(word attr) {
  _setbkcolor(attr >> 4);
  _settextcolor(attr & 0x0f);
}

int textcols() {
  struct videoconfig vc;
  _getvideoconfig(&vc);
  return vc.numtextcols;
}

int textrows() {
  struct videoconfig vc;
  _getvideoconfig(&vc);
  return vc.numtextrows;
}
